import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import ImagePlaceholder from '@s-ui/react-image-placeholder';

var ImagePicker =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(ImagePicker, _Component);

  function ImagePicker(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _this._buttonAction = function (callback) {
      var _this$state = _this.state,
          images = _this$state.images,
          selected = _this$state.selected;

      if (selected === -1) {
        return;
      }

      callback(images[selected]);
    };

    var defaultAlt = props.defaultAlt,
        emptyImage = props.emptyImage,
        _images = props.images,
        _selected = props.selected;
    var selectedImage = -1;

    if (_images.length !== 0) {
      selectedImage = _images[_selected] ? _selected : 0;
    }

    _this.state = {
      images: _images,
      selected: selectedImage
    };
    _this.placeHolder = {
      alt: defaultAlt,
      src: emptyImage
    };
    return _this;
  }

  var _proto = ImagePicker.prototype;

  _proto._getHeadImage = function _getHeadImage() {
    var _this$state2 = this.state,
        images = _this$state2.images,
        selected = _this$state2.selected;
    var _this$props = this.props,
        defaultAlt = _this$props.defaultAlt,
        emptyImage = _this$props.emptyImage;
    var src = selected === -1 ? emptyImage : images[selected].src;
    var alt = selected === -1 ? defaultAlt : images[selected].alt;
    return React.createElement(ImagePlaceholder, {
      src: src,
      alt: alt,
      placeholder: this.placeHolder
    });
  };

  _proto._getListImages = function _getListImages() {
    var _this2 = this;

    var _this$state3 = this.state,
        images = _this$state3.images,
        selected = _this$state3.selected;
    var imageList = images.map(function (image, index) {
      var itemClass = cx('sui-ImagePicker-thumbItem', {
        'sui-ImagePicker-thumbItem--selected': index === selected
      });
      return React.createElement("li", {
        className: itemClass,
        key: image.src,
        onClick: function onClick() {
          return _this2._handleClick(image);
        }
      }, React.createElement("img", {
        src: image.thumb,
        alt: image.alt,
        title: image.alt
      }));
    });
    return imageList;
  };

  _proto._handleClick = function _handleClick(clickedImage) {
    var images = this.state.images;
    var onClick = this.props.onClick;
    var selected = images.findIndex(function (image) {
      return image.src === clickedImage.src;
    });
    this.setState({
      selected: selected
    });
    onClick(clickedImage);
  };

  _proto._displayActions = function _displayActions(actions) {
    var _this3 = this;

    var actionList = actions.map(function (action, index) {
      return React.createElement("div", {
        className: "sui-ImagePicker-action",
        key: index,
        onClick: function onClick() {
          return _this3._buttonAction(action.callback);
        }
      }, action.node);
    });
    return React.createElement("div", {
      className: "sui-ImagePicker-actions"
    }, actionList);
  };

  _proto.render = function render() {
    var actions = this.props.actions;
    var images = this.state.images;
    return React.createElement("div", {
      className: "sui-ImagePicker"
    }, React.createElement("div", null, React.createElement("div", {
      className: "sui-ImagePicker-headImage"
    }, this._getHeadImage()), actions.length > 0 && this._displayActions(actions)), images.length > 0 && React.createElement("ul", {
      className: "sui-ImagePicker-thumbList"
    }, this._getListImages()));
  };

  return ImagePicker;
}(Component);

ImagePicker.displayName = 'ImagePicker';
ImagePicker.defaultProps = {
  actions: [],
  images: [],
  onClick: function onClick() {},
  selected: -1
};
export default ImagePicker;